/*
For information on this software or to report bugs please visit http://www.ranton.org
or email ranton@ranton.org

For custom software development and consulting please visit http://www.madlogic.com .

Copyright (c) 2007, Richard Neal Anton
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

*	Redistributions of source code must retain the above copyright notice, this list
	of conditions and the following disclaimer. 

*	Redistributions in binary form must reproduce the above copyright notice, this list
	of conditions and the following disclaimer in the documentation and/or other materials
	provided with the distribution. 

*	The name of the copyright holder may not be used to endorse or promote products 
	derived from this software without specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

 ////////                 
   //    //    ////////    This file is part of rqal, a.k.a. _Richard's Quality Library_ .
   //    //   //    //     Visit http://www.ranton.org for more information.
   //////     //    //     Email ranton@ranton.org for support or licensing.  
   //   //     //// //     
   //    //          //    Copyright (c) 2007 Richard Neal Anton
   //    //          //    All Rights Reserved.
  ///    //           //

#ifndef __RQ_ASSERT__
#include "rq_assert.h"
#endif

#ifndef __RQ_LOG__
#include "rq_log.h"
#endif

static RqAssertCallback sAssertCallback = 0;

// -- Failed assertions are handled by this.
void _RqAssertFailed(const char *filename, int lineno, const char *function, const char *condition)
{
	// Log it
	if( function )
		RqLog(RqLog_ASSERT,"Assertion %s failed in %s() at %s:%d",
				condition,function,filename,lineno);
	else
		RqLog(RqLog_ASSERT,"Assertion %s failed at %s:%d",
				condition,filename,lineno);

	// then call the assertion handler if any.
	if( sAssertCallback )
		sAssertCallback(filename,lineno,function,condition);
}


// this allows you to handle assertions however you like,
// _RqAssertFailed will still log them first before calling
// the callback, but you can disable that by setting the log mask 
RqAssertCallback RqSetAssertCallback(RqAssertCallback inCallback)
{
	RqAssertCallback old = sAssertCallback;
	sAssertCallback  = inCallback;
	return old;
}

