/*
For information on this software or to report bugs please visit http://www.ranton.org
or email ranton@ranton.org

For custom software development and consulting please visit http://www.madlogic.com .

Copyright (c) 2007, Richard Neal Anton
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

*	Redistributions of source code must retain the above copyright notice, this list
	of conditions and the following disclaimer. 

*	Redistributions in binary form must reproduce the above copyright notice, this list
	of conditions and the following disclaimer in the documentation and/or other materials
	provided with the distribution. 

*	The name of the copyright holder may not be used to endorse or promote products 
	derived from this software without specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

 ////////                 
   //    //    ////////    This file is part of rqal, a.k.a. _Richard's Quality Library_ .
   //    //   //    //     Visit http://www.ranton.org for more information.
   //////     //    //     Email ranton@ranton.org for support or licensing.  
   //   //     //// //     
   //    //          //    Copyright (c) 2007 Richard Neal Anton
   //    //          //    All Rights Reserved.
  ///    //           //

#ifndef __RQ_ERROR__
#include "rq_error.h"
#endif

#ifndef __RQ_LOG__
#include "rq_log.h"
#endif

RqError::RqError(int inErrVal)
{
	mValue = inErrVal;
	mLine = 0;
	mFile[0] = 0;
	mMessage[0] = 0;
}

RqError::~RqError()
{
}

// set additional associated error data.
void RqError::SetErrorData(int line, const char *file, const char *message)
{
	mLine = line;

	int i;
	char *dst;

	i = MAX_ERROR_MESSAGE_LEN;
	dst = mFile;
	while(file && *file && i)
	{
		*dst++ = *file++;
		i--;
	}
	*dst = 0;

	i = MAX_ERROR_MESSAGE_LEN;
	dst = mMessage;
	while(message && *message && i)
	{
		*dst++ = *message++;
		i--;
	}
	*dst = 0;
}

// convenience function for throwing an error.
void RqError::Throw(int value, int line, const char *file, const char *message)
{
	// Log the error
	RqLog(RqLog_ERROR,"%s (# %d) @ %s:%d",message,value,file,line);
	RqError err(value);
	err.SetErrorData(line,file,message);
	throw err;
}
